﻿;Formel für x-Position: 0+n*35  	;Breite: 35*4=140
;Formel für y-Position: 17,5+n*35	;Höhe: 35*3=105

;Werte beim Start initialisieren
RasterX=35
Rastery=35
RasteryOffset=17.5
elementbreite=140
elementhöhe=105
textgröße=15
Offsetx=0
Offsety=0

allesNeuzeichnen(ByRef Variable,bildw,bildh)
{
	global
	
	; We first want the hwnd (handle to the picture control) so that we know where to put the bitmap we create
	; We also want to width and height (posw and Posh)
	;GuiControlGet, Pos, Pos, Variable
	GuiControlGet, hwnd, hwnd, Variable
	
	TextOptions:=" s" (textgröße*zoomfaktor) " Center cff000000  Bold"
	TextOptionsMarkiert:=" s" (textgröße*zoomfaktor) " Center cff00aa00  Bold"
	Font:="Arial"
	Posw=%bildw%
	Posh=%bildh%
	
	
	; Create 2 brushes, one for the background and one for the foreground. Remember this is in ARGB
	pPenDünnGrau:=Gdip_CreatePen("0xff999999",1)
	pPenBlack := Gdip_CreatePen("0xff000000",2)
	pPenMarkLin := Gdip_CreatePen("0xff00aa00",2)
	pPenGrey := Gdip_CreatePen("0xffaaaaff",2)
	pBrushBlack := Gdip_BrushCreateSolid("0xff000000")
	pBrushUnmark := Gdip_BrushCreateSolid("0xfffafafa")
	pBrushMark := Gdip_BrushCreateSolid("0x5000ff00")
	
	
	
	; Create a gdi+ bitmap the width and height that we found the picture control to be
	; We will then get a reference to the graphics of this bitmap
	; We will also set the smoothing mode of the graphics to 4 (Antialias) to make the shapes we use smooth
	pBitmap := Gdip_CreateBitmap(Posw, Posh)
	G := Gdip_GraphicsFromImage(pBitmap)
	Gdip_SetSmoothingMode(G, 4)
	
	
	;Raster malen
	tempy:=round(Offsety/(Rastery)) * Rastery - 17.5
	tempx1:=round(Offsetx/(Rasterx)) * Rasterx
	tempxanzahl:=round(widthofguipic/(Rasterx*zoomfaktor))+1
	tempyanzahl:=round(heightofguipic/(Rastery*zoomfaktor))+1
	Loop %tempyanzahl%
	{
		tempx:=tempx1
		Loop %tempxanzahl%
		{
			Gdip_DrawLine(G, pPenDünnGrau, ((tempx-Offsetx-5)*zoomfaktor), ((tempy-Offsety)*zoomfaktor), ((tempx-Offsetx+5)*zoomfaktor), ((tempy-Offsety)*zoomfaktor))
			Gdip_DrawLine(G, pPenDünnGrau, ((tempx-Offsetx)*zoomfaktor), ((tempy-Offsety-5)*zoomfaktor), ((tempx-Offsetx)*zoomfaktor), ((tempy-Offsety+5)*zoomfaktor))
			
			tempx:=tempx+rasterx
		}
		;MsgBox,% (tempx-2) "  " (tempy) "  " (tempx+2) "  " (tempy)
		tempy:=tempy+Rastery
		;MsgBox,% (tempx-2) "  " (tempy) "  " (tempx+2) "  " (tempy)
	}
	
	for index, element in alleElemente
	{
		if %element%typ=Trigger
		{
			Gdip_FillRoundedRectangle(G, pBrushUnmark, ((%element%x-Offsetx)*ZoomFaktor), ((%element%y-Offsety)*ZoomFaktor), ((elementbreite)*ZoomFaktor), ((elementhöhe)*ZoomFaktor),(30*ZoomFaktor))
			Gdip_DrawroundedRectangle(G, pPenGrey, ((%element%x-Offsetx)*ZoomFaktor), ((%element%y-Offsety)*ZoomFaktor), ((elementbreite)*ZoomFaktor), ((elementhöhe)*ZoomFaktor),(30*ZoomFaktor))
			Gdip_TextToGraphics(G, %element%name, "x" ((%element%x-Offsetx)*ZoomFaktor +4) "y" ((%element%y-Offsety)*ZoomFaktor+4) TextOptions, Font, ((elementbreite)*ZoomFaktor-8), ((elementhöhe)*ZoomFaktor-8))
			
			if %element%markiert=true
				Gdip_FillroundedRectangle(G, pBrushMark, ((%element%x-Offsetx)*ZoomFaktor), ((%element%y-Offsety)*ZoomFaktor), ((elementbreite)*ZoomFaktor), ((elementhöhe)*ZoomFaktor),(30*ZoomFaktor))
			
			;MsgBox,% "x" (%element%x*ZoomFaktor +4) "y" (%element%y*ZoomFaktor+4) TextOptions Font (180*ZoomFaktor-8) (135*ZoomFaktor-8)
			;Klickbare Fläche definieren
			%element%klick1x1:=((%element%x-Offsetx)*ZoomFaktor)
			%element%klick1y1:=((%element%y-Offsety)*ZoomFaktor)
			%element%klick1x2:=((%element%x-Offsetx)*ZoomFaktor)+(elementbreite*ZoomFaktor)
			%element%klick1y2:=((%element%y-Offsety)*ZoomFaktor)+(elementhöhe*ZoomFaktor)
			;MsgBox,% "x1 " %element%klick1x1 " y1 " %element%klick1y1 " x2 " %element%klick1x2 "y2" %element%klick1y2
			%element%klickAnzahl=1
			%element%klickPriorität=500
		}
		if %element%typ=Action
		{
			;gdipTriggerZeichnen(%element%pic,%element%name)
			Gdip_FillRectangle(G, pBrushUnmark, ((%element%x-Offsetx)*ZoomFaktor), ((%element%y-Offsety)*ZoomFaktor), ((elementbreite)*ZoomFaktor), ((elementhöhe)*ZoomFaktor))
			Gdip_DrawRectangle(G, pPenGrey, ((%element%x-Offsetx)*ZoomFaktor), ((%element%y-Offsety)*ZoomFaktor), ((elementbreite)*ZoomFaktor), ((elementhöhe)*ZoomFaktor))
			Gdip_TextToGraphics(G, %element%name, "x" ((%element%x-Offsetx)*ZoomFaktor +4) "y" ((%element%y-Offsety)*ZoomFaktor+4) TextOptions, Font, ((elementbreite)*ZoomFaktor-8), ((elementhöhe)*ZoomFaktor-8))
			Gdip_TextToGraphics(G, %element%name, "x" ((%element%x-Offsetx)*ZoomFaktor +4) "y" ((%element%y-Offsety)*ZoomFaktor+4) TextOptions, Font, ((elementbreite)*ZoomFaktor-8), (elementhöhe*ZoomFaktor-8))
			if %element%markiert=true
				Gdip_FillRectangle(G, pBrushMark, ((%element%x-Offsetx)*ZoomFaktor), ((%element%y-Offsety)*ZoomFaktor), (elementbreite*ZoomFaktor), (elementhöhe*ZoomFaktor))
			;MsgBox, % element "`n" %element%markiert
			
			;Klickbare Fläche definieren
			%element%klick1x1:=((%element%x-Offsetx)*ZoomFaktor)
			%element%klick1y1:=((%element%y-Offsety)*ZoomFaktor)
			%element%klick1x2:=((%element%x-Offsetx)*ZoomFaktor)+(elementbreite*ZoomFaktor)
			%element%klick1y2:=((%element%y-Offsety)*ZoomFaktor)+(elementhöhe*ZoomFaktor)
			%element%klickAnzahl=1
			%element%klickPriorität=500
		}
		if %element%typ=Condition
		{
			Gdip_FillRoundedRectangle(G, pBrushUnmark, ((%element%x-Offsetx)*ZoomFaktor), ((%element%y-Offsety)*ZoomFaktor), (elementbreite*ZoomFaktor), (elementhöhe*ZoomFaktor),(30*ZoomFaktor))
			;Gdip_FillPolygon(G, pBrushUnmark,((%element%x+elementbreite/2)*ZoomFaktor) "," ((%element%y+0)*ZoomFaktor) "|" ((%element%x+elementbreite)*ZoomFaktor) "," ((%element%y+elementhöhe/2)*ZoomFaktor) "|" ((%element%x+elementbreite/2)*ZoomFaktor) "," ((%element%y+elementhöhe)*ZoomFaktor) "|" ((%element%x+0)*ZoomFaktor) "," ((%element%y+elementhöhe/2)*ZoomFaktor) "|" ((%element%x+elementbreite/2)*ZoomFaktor) "," ((%element%y+0)*ZoomFaktor))
			Gdip_DrawLines(G, pPenGrey,((%element%x+elementbreite/2-Offsetx)*ZoomFaktor) "," ((%element%y+0-Offsety)*ZoomFaktor) "|" ((%element%x+elementbreite-Offsetx)*ZoomFaktor) "," ((%element%y+elementhöhe/2-Offsety)*ZoomFaktor) "|" ((%element%x+elementbreite/2-Offsetx)*ZoomFaktor) "," ((%element%y+elementhöhe-Offsety)*ZoomFaktor) "|" ((%element%x+0-Offsetx)*ZoomFaktor) "," ((%element%y+elementhöhe/2-Offsety)*ZoomFaktor) "|" ((%element%x+elementbreite/2-Offsetx)*ZoomFaktor) "," ((%element%y+0-Offsety)*ZoomFaktor))
			
			Gdip_TextToGraphics(G, %element%name, "x" ((%element%x-Offsetx)*ZoomFaktor +4) "y" ((%element%y-Offsety)*ZoomFaktor+4) TextOptions, Font, (elementbreite*ZoomFaktor-8), (elementhöhe*ZoomFaktor-8))
			if %element%markiert=true
				Gdip_FillroundedRectangle(G, pBrushMark, ((%element%x-Offsetx)*ZoomFaktor), ((%element%y-Offsety)*ZoomFaktor), (elementbreite*ZoomFaktor), (elementhöhe*ZoomFaktor),(30*ZoomFaktor))
				
			;Klickbare Fläche definieren
			%element%klick1x1:=((%element%x-Offsetx)*ZoomFaktor)
			%element%klick1y1:=((%element%y-Offsety)*ZoomFaktor)
			%element%klick1x2:=((%element%x-Offsetx)*ZoomFaktor)+(elementbreite*ZoomFaktor)
			%element%klick1y2:=((%element%y-Offsety)*ZoomFaktor)+(elementhöhe*ZoomFaktor)
			%element%klickAnzahl=1
			%element%klickPriorität=500
		}
		
		
		if %element%typ=Verbindung
		{
			;msgbox,% %Element%Von "Pic"
			;msgbox,% %Element%Nach "Pic"
			tempvonEL:=%Element%Von
			tempzuEl:=%Element%Nach
			;msgbox,% tempvonEL "`n" %tempvonEL%x
			;gdipVerbinden(%temp%Pic,%temp2%Pic)
			;gdipVerbinden(element,%temp1%Pic,%temp2%Pic,,%element%Verbindungstyp)
			
			
			StartPosx:=%tempvonEL%x+(elementbreite/2)
			StartPosy:=%tempvonEL%y+elementhöhe
			ZielPosx:=%tempzuEl%x+(elementbreite/2)
			ZielPosy:=%tempzuEl%y
			;MsgBox
			lin1x:=startposx
			lin1y:=startposy
			lin1w:=0
			if ((zielposy-startposy)<20)
			{
				lin1h:=10
			}
			else
			{
				lin1h:=(zielposy-StartPosy)/2
			}
			
			
			
			lin2y:=lin1y+lin1h
			lin2h:=0
			if (ZielPosx>StartPosx)
			{
				lin2x:=lin1x
				lin2w:=(ZielPosx-StartPosx)/2
				if (lin2w<elementbreite/2 +5 and StartPosy>ZielPosy)
					lin2w:=elementbreite/2+5
				if (zielposx-elementbreite/2-5<lin2x+lin2w and StartPosy>ZielPosy)
				{
					lin2w:=zielposx+elementbreite/2+5-lin2x
					
				}
				
				
			}
			else
			{
				
				lin2w:=(StartPosx- ZielPosx)/2
				
				if (lin2w<elementbreite/2 +5 and StartPosy>ZielPosy)
					lin2w:=elementbreite/2+5
				lin2x:=lin1x-lin2w
				if (zielposx+elementbreite/2+5>lin2x and StartPosy>ZielPosy)
				{
					lin2x:=zielposx-elementbreite/2-5
					lin2w:=lin1x-lin2x
					
				}
					
				
			}
			
			
			lin3w:=0
			if (ZielPosx>StartPosx)
			{
				
				
				lin3x:=lin2x+lin2w
			}
			else
			{
				
				lin3x:=lin2x
			}
			
			
			
			
			if (StartPosy>ZielPosy-20)
			{
				
				lin3y:=ZielPosy-10
				lin3h:=lin2y-lin3y
			}
			else
			{
				lin3h:=0
				lin3y:=lin2y
				
			}
			
			
			lin4y:=lin3y
			lin4h:=0
			if (ZielPosx>lin3x)
			{
				lin4x:=lin3x
				lin4w:=(ZielPosx-lin4x)
				
			}
			else
			{
				
				lin4x:=zielposx
				lin4w:=(lin3x-lin4x)
				
			}
			
			
			lin5x:=zielposx
			
			lin5w:=0
			if ((zielposy-startposy)<20)
			{
				lin5h:=10
				lin5y:=zielposy-lin5h
			}
			else
			{
				lin5h:=(zielposy-StartPosy)/2
				lin5y:=zielposy-lin5h
			}
			
			if (not (%element%Verbindungstyp="normal"))
			{
				if (%element%verbindungstyp="ja")
				{
					schrx:=zielposx-25
					schrw:=25
				}
				else
				{
					schrx:=zielposx+5
					schrw:=45
				}
				Aufschrift:=zielposx
				
				schrh:=15
				
				schry:=zielposy-schrh
				;Gdip_TextToGraphics(G, verbindungstyp, TextOptions, Font, posw, posh)
				
				;guicontrol,move,%element%schr, x%schrx% y%schry% w%schrw% h%schrh% 
				;gdipTextZeichnen(%element%schr,schrw,schrh,verbindungstyp,markiert)
				if %element%markiert=true
					Gdip_TextToGraphics(G, %element%verbindungstyp, "x" ((schrx-Offsetx)*ZoomFaktor) "y" ((schry-Offsety)*ZoomFaktor) TextOptionsMarkiert, Font, (schrw*ZoomFaktor), (schrh*ZoomFaktor))
				else
					Gdip_TextToGraphics(G, %element%verbindungstyp, "x" ((schrx-Offsetx)*ZoomFaktor) "y" ((schry-Offsety)*ZoomFaktor) TextOptions, Font, (schrw*ZoomFaktor), (schrh*ZoomFaktor))
				
				;Gdip_TextToGraphics(G, %element%name, "x" ((%element%x-Offsetx)*ZoomFaktor +4) "y" ((%element%y-Offsety)*ZoomFaktor+4) TextOptions, Font, ((elementbreite)*ZoomFaktor-8), ((elementhöhe)*ZoomFaktor-8))
			}
			
			
			
			;MsgBox,% markiert
			;msgbox,x%lin3x% y%lin3y% w%lin3w% h%lin3h%`nx%lin4x% y%lin4y% w%lin4w% h%lin4h%
			;msgbox,x%lin1x% y%lin1y% w%lin1w% h%lin1h%
			
			
			
			%element%klickAnzahl=0
			
			loop 5
			{
				if %element%markiert=true
					Gdip_DrawLine(G, pPenMarkLin, ((lin%a_index%x-Offsetx)*zoomfaktor), ((lin%a_index%y-Offsety)*zoomfaktor), ((lin%a_index%x+lin%a_index%w-Offsetx)*zoomfaktor) , ((lin%a_index%y+lin%a_index%h-Offsety)*zoomfaktor))
				else
					Gdip_DrawLine(G, pPenBlack, ((lin%a_index%x-Offsetx)*zoomfaktor), ((lin%a_index%y-Offsety)*zoomfaktor), ((lin%a_index%x+lin%a_index%w-Offsetx)*zoomfaktor) , ((lin%a_index%y+lin%a_index%h-Offsety)*zoomfaktor))
				;Klickbare Fläche definieren
				%element%klick%a_index%x1:=((lin%a_index%x-20-Offsetx)*zoomfaktor)
				%element%klick%a_index%y1:=((lin%a_index%y-20-Offsety)*zoomfaktor)
				%element%klick%a_index%x2:=((lin%a_index%x+lin%a_index%w+20-Offsetx)*zoomfaktor)
				%element%klick%a_index%y2:=((lin%a_index%y+lin%a_index%h+20-Offsety)*zoomfaktor)
				%element%klickAnzahl++
				%element%klickPriorität=200
			}
			
		}
	}
	
	
	
	
	
	
	
	
	;if markiert=true
	;{
	;	pBrushMark := Gdip_BrushCreateSolid(Markcolor)
	;	Gdip_FillRectangle(G, pBrushMark, posx, posy, posw-2, posh-2)
	;	
	;}
	
	
	; We then get a gdi bitmap from the gdi+ one we've been working with...
	hBitmap := Gdip_CreateHBITMAPFromBitmap(pBitmap)
	; ... and set it to the hwnd we found for the picture control
	
	
	SetImage(hwnd, hBitmap)
	
	; We then must delete everything we created
	; So the 2 brushes must be deleted
	; Then we can delete the graphics, our gdi+ bitmap and the gdi bitmap
	Gdip_Deletepen(pPenBlack), Gdip_DeleteBrush(pBrushBlack), Gdip_DeleteBrush(pBrushMark)
	Gdip_DeleteGraphics(G), Gdip_DisposeImage(pBitmap), DeleteObject(hBitmap)
	Return, 0
	
	
	
	
	
	for index, element in alleElemente
	{
		if %element%typ=Trigger
		{
			gdipTriggerZeichnen(%element%pic,%element%name)
		}
		if %element%typ=Action
		{
			gdipActionZeichnen(%element%pic,%element%name)
		}
		if %element%typ=Condition
		{
			gdipConditionZeichnen(%element%pic,%element%name)
		}
		if %element%typ=Verbindung
		{
			;msgbox,% %Element%Von "Pic"
			;msgbox,% %Element%Nach "Pic"
			temp1:=%Element%Von
			temp2:=%Element%Nach
			;msgbox,% temp2 "pic"
			;gdipVerbinden(%temp%Pic,%temp2%Pic)
			gdipVerbinden(element,%temp1%Pic,%temp2%Pic,,%element%Verbindungstyp)
			
			
			
		}
	}
	
	for index, element in markierteElemente
	{
		if %element%typ=Trigger
		{
			gdipTriggerZeichnen(%element%pic,%element%name,%element%markiert)
			;MsgBox,% %element%name
		}
		if %element%typ=Action
		{
			gdipActionZeichnen(%element%pic,%element%name,%element%markiert)
		}
		if %element%typ=Condition
		{
			gdipConditionZeichnen(%element%pic,%element%name,%element%markiert)
		}
		if %element%typ=Verbindung
		{
			;msgbox,% %Element%Von "Pic"
			;msgbox,% %Element%Nach "Pic"
			temp1:=%Element%Von
			temp2:=%Element%Nach
			;msgbox,% temp2 "pic"
			;gdipVerbinden(%temp%Pic,%temp2%Pic)
			gdipVerbinden(element,%temp1%Pic,%temp2%Pic,%element%markiert,%element%Verbindungstyp)
		}
		
		if ((%element%typ="Verbindung" or %element%typ="Action" or %element%typ="Trigger") and markierteElemente.MaxIndex()=1)
		{
			
			
			
			
		}
	}
	
	
	
	
	
}



elementBildLöschen(element)
{
	global
	if (%element%typ="Action" or %element%typ="Condition")
	{
		guicontrol,hide,%element%pic
	}
	
	if %element%typ=Verbindung
	{
		guicontrol,hide,%element%lin1
		guicontrol,hide,%element%lin2
		guicontrol,hide,%element%lin3
		guicontrol,hide,%element%lin4
		guicontrol,hide,%element%lin5
		
	}
	
	
}


NeuTrigger()
{
	global
	alleElemente.insert("t"zahl)
	
	
	
	t%zahl%markiert=false
	t%zahl%Typ=Trigger
	t%zahl%Name=Trigger
	t%zahl%x=20
	t%zahl%y=20
	zahl++
	TriggerAnzahl++
	
}

NeuAction()
{
	global
	alleElemente.insert("t"zahl)
	t%zahl%markiert=false
	;gui,add,picture, h50 w50 x200 y200 vt%zahl%pic 0xE gmovePic +Transparent
	
	t%zahl%Typ=Action
	t%zahl%Name=Action
	t%zahl%x=20
	t%zahl%y=20
	zahl++ 
	ActionAnzahl++
}

NeuCondition()
{
	global
	alleElemente.insert("t"zahl)
	t%zahl%markiert=false
	;gui,add,picture, h10 w10 x200 y200 vt%zahl%pic 0xE gmovePic +Transparent
	t%zahl%picGehörtZu=t%zahl%
	t%zahl%Typ=Condition
	t%zahl%Name=Condition
	t%zahl%x=20
	t%zahl%y=20
	zahl++
	ConditionAnzahl++
}

NeuVerbindung(von,nach,Verbindungstyp="normal")
{
	global
	alleElemente.insert("Verbindung"zahl)
	Verbindung%zahl%Von:=von
	Verbindung%zahl%Nach:=nach
	Verbindung%zahl%markiert=false
	Verbindung%zahl%Typ=Verbindung
	Verbindung%zahl%Verbindungstyp=%Verbindungstyp%
	
	
	;gui,add,picture, x0 y0 w0 h0 vVerbindung%zahl%schr 0xE
	Verbindung%zahl%schrGehörtZu=Verbindung%zahl%
	
	;gui,add,picture, x0 y0 w0 h0 vVerbindung%zahl%lin1 0xE glinienKlick
	Verbindung%zahl%lin1GehörtZu=Verbindung%zahl%
	
	;gui,add,picture, x0 y0 w0 h0 vVerbindung%zahl%lin2 0xE glinienKlick
	Verbindung%zahl%lin2GehörtZu=Verbindung%zahl%
	
	;gui,add,picture, x0 y0 w0 h0 vVerbindung%zahl%lin3 0xE glinienKlick
	Verbindung%zahl%lin3GehörtZu=Verbindung%zahl%
	
	;gui,add,picture, x0 y0 w0 h0 vVerbindung%zahl%lin4 0xE glinienKlick
	Verbindung%zahl%lin4GehörtZu=Verbindung%zahl%
	
	;gui,add,picture, x0 y0 w0 h0 vVerbindung%zahl%lin5 0xE glinienKlick
	Verbindung%zahl%lin5GehörtZu=Verbindung%zahl%
	
	AnzahlVerbindungen++
	zahl++
	
}

gdipActionZeichnen(ByRef Variable, Text="Action",markiert="false " )
{
	; We first want the hwnd (handle to the picture control) so that we know where to put the bitmap we create
	; We also want to width and height (posw and Posh)
	;GuiControlGet, Pos, Pos, Variable
	GuiControlGet, hwnd, hwnd, Variable
	Foreground=0xff000000
	Markcolor=0x8000ff00
	TextOptions:="x0p y15p s10 Center cff000000  Bold"
	Font:="Arial"
	Posw=80
	Posh=60
	
	
	; Create 2 brushes, one for the background and one for the foreground. Remember this is in ARGB
	pPenFront := Gdip_CreatePen(Foreground,2)
	
	
	; Create a gdi+ bitmap the width and height that we found the picture control to be
	; We will then get a reference to the graphics of this bitmap
	; We will also set the smoothing mode of the graphics to 4 (Antialias) to make the shapes we use smooth
	pBitmap := Gdip_CreateBitmap(Posw, Posh)
	G := Gdip_GraphicsFromImage(pBitmap)
	Gdip_SetSmoothingMode(G, 4)
	
	
	
	; We will then fill a rounded rectangle with our other brush, starting at x = 4 and y = 4
	; The total width is now Posw-8 as we have slightly indented the actual progress bar
	; The last parameter which is the amount the corners will be rounded by in pixels has been made to be 3 pixels...
	; ...however I have made it so that they are smaller if the percentage is too small as it cannot be rounded by that much
	;Gdip_FillRoundedRectangle(G, pBrushFront, 4, 4, (Posw-8)*(Percentage/100), Posh-8, (Percentage >= 3) ? 3 : Percentage)
	Gdip_DrawRectangle(G, pPenFront, posx, posy, posw-2, posh-2)
	
	; As mentioned in previous examples, we will provide Gdip_TextToGraphics with the width and height of the graphics
	; We will then write the percentage centred onto the graphics (Look at previous examples to understand all options)
	; I added an optional text parameter at the top of this function, to make it so you could write an indication onto the progress bar
	; such as "Finished!" or whatever, otherwise it will write the percentage to it
	Gdip_TextToGraphics(G, text, TextOptions, Font, posw, posh)
	
	
	if markiert=true
	{
		pBrushMark := Gdip_BrushCreateSolid(Markcolor)
		Gdip_FillRectangle(G, pBrushMark, posx, posy, posw-2, posh-2)
		
	}
	
	
	; We then get a gdi bitmap from the gdi+ one we've been working with...
	hBitmap := Gdip_CreateHBITMAPFromBitmap(pBitmap)
	; ... and set it to the hwnd we found for the picture control
	SetImage(hwnd, hBitmap)
	
	; We then must delete everything we created
	; So the 2 brushes must be deleted
	; Then we can delete the graphics, our gdi+ bitmap and the gdi bitmap
	Gdip_Deletepen(pBrushFront)
	Gdip_DeleteGraphics(G), Gdip_DisposeImage(pBitmap), DeleteObject(hBitmap)
	Return, 0
}

gdipTriggerZeichnen(ByRef Variable, Text="Action",markiert="false"  )
{
	; We first want the hwnd (handle to the picture control) so that we know where to put the bitmap we create
	; We also want to width and height (posw and Posh)
	;GuiControlGet, Pos, Pos, Variable
	GuiControlGet, hwnd, hwnd, Variable
	Foreground=0xff000000
	Markcolor=0x8000ff00
	TextOptions:="x0p y15p s10 Center cff000000  Bold"
	Font:="Arial"
	Posw=80
	Posh=60
	
	
	; Create 2 brushes, one for the background and one for the foreground. Remember this is in ARGB
	pPenFront := Gdip_CreatePen(Foreground,2)
	
	
	; Create a gdi+ bitmap the width and height that we found the picture control to be
	; We will then get a reference to the graphics of this bitmap
	; We will also set the smoothing mode of the graphics to 4 (Antialias) to make the shapes we use smooth
	pBitmap := Gdip_CreateBitmap(Posw, Posh)
	G := Gdip_GraphicsFromImage(pBitmap)
	Gdip_SetSmoothingMode(G, 4)
	
	
	
	; We will then fill a rounded rectangle with our other brush, starting at x = 4 and y = 4
	; The total width is now Posw-8 as we have slightly indented the actual progress bar
	; The last parameter which is the amount the corners will be rounded by in pixels has been made to be 3 pixels...
	; ...however I have made it so that they are smaller if the percentage is too small as it cannot be rounded by that much
	;Gdip_FillRoundedRectangle(G, pBrushFront, 4, 4, (Posw-8)*(Percentage/100), Posh-8, (Percentage >= 3) ? 3 : Percentage)
	Gdip_DrawRectangle(G, pPenFront, posx, posy, posw-2, posh-2)
	
	; As mentioned in previous examples, we will provide Gdip_TextToGraphics with the width and height of the graphics
	; We will then write the percentage centred onto the graphics (Look at previous examples to understand all options)
	; I added an optional text parameter at the top of this function, to make it so you could write an indication onto the progress bar
	; such as "Finished!" or whatever, otherwise it will write the percentage to it
	Gdip_TextToGraphics(G, text, TextOptions, Font, posw, posh)
	
	
	if markiert=true
	{
		pBrushMark := Gdip_BrushCreateSolid(Markcolor)
		Gdip_FillRectangle(G, pBrushMark, posx, posy, posw-2, posh-2)
		
	}
	
	
	; We then get a gdi bitmap from the gdi+ one we've been working with...
	hBitmap := Gdip_CreateHBITMAPFromBitmap(pBitmap)
	; ... and set it to the hwnd we found for the picture control
	SetImage(hwnd, hBitmap)
	
	; We then must delete everything we created
	; So the 2 brushes must be deleted
	; Then we can delete the graphics, our gdi+ bitmap and the gdi bitmap
	Gdip_Deletepen(pBrushFront)
	Gdip_DeleteGraphics(G), Gdip_DisposeImage(pBitmap), DeleteObject(hBitmap)
	Return, 0
}


gdipConditionZeichnen(ByRef Variable, Text="Action",markiert="false"  )
{
	; We first want the hwnd (handle to the picture control) so that we know where to put the bitmap we create
	; We also want to width and height (posw and Posh)
	;GuiControlGet, Pos, Pos, Variable
	GuiControlGet, hwnd, hwnd, Variable
	Foreground=0xff000000
	Markcolor=0x8000ff00
	TextOptions:="x0p y15p s10 Center cff000000  Bold"
	Font:="Arial"
	Posw=80
	Posh=60
	Width:=80
	Height:=80
	Angle=45
	; Create 2 brushes, one for the background and one for the foreground. Remember this is in ARGB
	pPenFront := Gdip_CreatePen(Foreground,2)
	
	
	; Create a gdi+ bitmap the width and height that we found the picture control to be
	; We will then get a reference to the graphics of this bitmap
	; We will also set the smoothing mode of the graphics to 4 (Antialias) to make the shapes we use smooth
	pBitmap := Gdip_CreateBitmap(Posw, Posh)
	G := Gdip_GraphicsFromImage(pBitmap)
	Gdip_SetSmoothingMode(G, 4)
	
	
	; As mentioned in previous examples, we will provide Gdip_TextToGraphics with the width and height of the graphics
	; We will then write the percentage centred onto the graphics (Look at previous examples to understand all options)
	; I added an optional text parameter at the top of this function, to make it so you could write an indication onto the progress bar
	; such as "Finished!" or whatever, otherwise it will write the percentage to it
	Gdip_TextToGraphics(G, text, TextOptions, Font, posw, posh)
	
	
	
	
	Gdip_ScaleWorldTransform(G,0.7071067811865475,0.7071067811865475)
	Gdip_ScaleWorldTransform(G,1,60/80)
	; When rotating a square image, then the bitmap or canvas will need to be bigger as you can imagine that once rotated then a triangle will be wider than a square
	; We need to know the new dimensions of the image
	; With Gdip_GetRotatedDimensions we can plug in the width and height of the image, and the angle it is to be rotated by
	; The last 2 parameters are the variables in which tio store the new width and height of the rotated image
	; RWidth and RHeight now contain the dimensions of the rotated image
	Gdip_GetRotatedDimensions(Width, Height, Angle, RWidth, RHeight)

	; We rotate an image about the top left corner of the image, however this will result in the image moving off the canvas
	; We can use Gdip_GetRotatedTranslation to find how much the image should be 'shifted' by in the x and y coordinates in order for it to be back on the canvas
	; As with the above function, we plug in the width, height and angle to rotate by
	; The function will then make the last 2 parameters the x and y translation (this is the distance in pixels the image must be shifted by)
	; xTranslation and yTranslation now contain the distance to shift the image by
	Gdip_GetRotatedTranslation(Width, Height, Angle, xTranslation, yTranslation)

	; We will now create a gdi bitmap to display the rotated image on the screen (as mentioned previously we must use a gdi bitmap to display things on the screen)
	hbm := CreateDIBSection(RWidth, RHeight)

	;msgbox,%width%`n%height%`n%RWidth%

	; We can now shift our graphics or 'canvas' using the values found with Gdip_GetRotatedTranslation so that the image will be drawn on the canvas
	Gdip_TranslateWorldTransform(G, xTranslation, yTranslation)

	; We can also rotate the graphics by the angle we desire
	Gdip_RotateWorldTransform(G, Angle)
	


	

	
	
	; We will then fill a rounded rectangle with our other brush, starting at x = 4 and y = 4
	; The total width is now Posw-8 as we have slightly indented the actual progress bar
	; The last parameter which is the amount the corners will be rounded by in pixels has been made to be 3 pixels...
	; ...however I have made it so that they are smaller if the percentage is too small as it cannot be rounded by that much
	;Gdip_FillRoundedRectangle(G, pBrushFront, 4, 4, (Posw-8)*(Percentage/100), Posh-8, (Percentage >= 3) ? 3 : Percentage)
	Gdip_DrawRectangle(G, pPenFront, posx, posy, Width-2, height-2)
	
	
	
	
	if markiert=true
	{
		pBrushMark := Gdip_BrushCreateSolid(Markcolor)
		Gdip_FillRectangle(G, pBrushMark, posx, posy, Width-2, height-2)
		
	}
	
	; Even though this is not necessary in this scenario, you should always reset the transforms set on the graphics. This will remove any of the rotations
	Gdip_ResetWorldTransform(G)
	
	
	; We then get a gdi bitmap from the gdi+ one we've been working with...
	hBitmap := Gdip_CreateHBITMAPFromBitmap(pBitmap)
	; ... and set it to the hwnd we found for the picture control
	SetImage(hwnd, hBitmap)
	
	
	Gdip_ResetWorldTransform(G)
	; We then must delete everything we created
	; So the 2 brushes must be deleted
	; Then we can delete the graphics, our gdi+ bitmap and the gdi bitmap
	Gdip_Deletepen(pBrushFront)
	Gdip_DeleteGraphics(G), Gdip_DisposeImage(pBitmap), DeleteObject(hBitmap)
	Return, 0
}

gdipTextZeichnen(ByRef Variable, Width, Height, Text="",markiert=false  )
{
	if text=""
		return
	
	; We first want the hwnd (handle to the picture control) so that we know where to put the bitmap we create
	; We also want to width and height (posw and Posh)
	;GuiControlGet, Pos, Pos, Variable
	GuiControlGet, hwnd, hwnd, Variable
	
	if markiert=true
		TextOptions:="x0p y15p s10  cff009900  Bold"
	else
		TextOptions:="x0p y15p s10  cff000000   Bold"
		
		
	
	
	Font:="Arial"
	Posw:=Width
	Posh:=Height
	
	
	
	
	
	; Create a gdi+ bitmap the width and height that we found the picture control to be
	; We will then get a reference to the graphics of this bitmap
	; We will also set the smoothing mode of the graphics to 4 (Antialias) to make the shapes we use smooth
	pBitmap := Gdip_CreateBitmap(Posw, Posh)
	G := Gdip_GraphicsFromImage(pBitmap)
	Gdip_SetSmoothingMode(G, 4)
	
	
	; As mentioned in previous examples, we will provide Gdip_TextToGraphics with the width and height of the graphics
	; We will then write the percentage centred onto the graphics (Look at previous examples to understand all options)
	; I added an optional text parameter at the top of this function, to make it so you could write an indication onto the progress bar
	; such as "Finished!" or whatever, otherwise it will write the percentage to it
	Gdip_TextToGraphics(G, text, TextOptions, Font, posw, posh)
	
	

	; We will now create a gdi bitmap to display the rotated image on the screen (as mentioned previously we must use a gdi bitmap to display things on the screen)
	hbm := CreateDIBSection(Width, Height)

	;msgbox,%width%`n%height%`n%RWidth%
	
	
	
	
	
	; We then get a gdi bitmap from the gdi+ one we've been working with...
	hBitmap := Gdip_CreateHBITMAPFromBitmap(pBitmap)
	; ... and set it to the hwnd we found for the picture control
	SetImage(hwnd, hBitmap)
	
	
	Gdip_ResetWorldTransform(G)
	; We then must delete everything we created
	; So the 2 brushes must be deleted
	; Then we can delete the graphics, our gdi+ bitmap and the gdi bitmap
	Gdip_Deletepen(pBrushFront)
	Gdip_DeleteGraphics(G), Gdip_DisposeImage(pBitmap), DeleteObject(hBitmap)
	Return, 0
}


gdipVerbinden(element,ByRef VonPic,ByRef ZuPic,markiert="false",Verbindungstyp="normal" )
{
	
	global 
	
	;Verbindungstyp=nein ;Test
	
	GuiControlGet, VonPos, Pos, VonPic
	GuiControlGet, ZuPos, Pos, ZuPic
	StartPosx:=VonPosx+(vonposw/2)
	StartPosy:=VonPosy+vonposh
	ZielPosx:=ZuPosx+(zuposw/2)
	ZielPosy:=ZuPosy
	
	lin1x:=startposx
	lin1y:=startposy
	lin1w:=2
	if ((zielposy-startposy)<20)
	{
		lin1h:=10
	}
	else
	{
		lin1h:=(zielposy-StartPosy)/2
	}
	
	
	
	lin2y:=lin1y+lin1h
	lin2h:=2
	if (ZielPosx>StartPosx)
	{
		lin2x:=lin1x
		lin2w:=(ZielPosx-StartPosx)/2
		if (lin2w<vonposw/2 +5 and StartPosy>ZielPosy)
			lin2w:=vonposw/2+5
		if (zielposx-zuposw/2-5<lin2x+lin2w and StartPosy>ZielPosy)
		{
			lin2w:=zielposx+zuposw/2+5-lin2x
			
		}
		
		
	}
	else
	{
		
		lin2w:=(StartPosx- ZielPosx)/2
		
		if (lin2w<vonposw/2 +5 and StartPosy>ZielPosy)
			lin2w:=vonposw/2+5
		lin2x:=lin1x-lin2w
		if (zielposx+zuposw/2+5>lin2x and StartPosy>ZielPosy)
		{
			lin2x:=zielposx-zuposw/2-5
			lin2w:=lin1x-lin2x
			
		}
			
		
	}
	
	
	lin3w:=2
	if (ZielPosx>StartPosx)
	{
		
		
		lin3x:=lin2x+lin2w
	}
	else
	{
		
		lin3x:=lin2x
	}
	
	
	
	
	if (StartPosy>ZielPosy-20)
	{
		
		lin3y:=ZielPosy-10
		lin3h:=lin2y-lin3y
	}
	else
	{
		lin3h:=0
		lin3y:=lin2y
		
	}
	
	
	lin4y:=lin3y
	lin4h:=2
	if (ZielPosx>lin3x)
	{
		lin4x:=lin3x
		lin4w:=(ZielPosx-lin4x)
		
	}
	else
	{
		
		lin4x:=zielposx
		lin4w:=(lin3x-lin4x)
		
	}
	
	
	lin5x:=zielposx
	
	lin5w:=2
	if ((zielposy-startposy)<20)
	{
		lin5h:=10
		lin5y:=zielposy-lin5h
	}
	else
	{
		lin5h:=(zielposy-StartPosy)/2
		lin5y:=zielposy-lin5h
	}
	
	if (not (Verbindungstyp="normal"))
	{
		if (verbindungstyp="ja")
		{
			schrx:=zielposx-15
			schrw:=15
		}
		else
		{
			schrx:=zielposx+5
			schrw:=25
		}
		Aufschrift:=zielposx
		
		schrh:=15
		
		schry:=zielposy-schrh
		guicontrol,move,%element%schr, x%schrx% y%schry% w%schrw% h%schrh% 
		gdipTextZeichnen(%element%schr,schrw,schrh,verbindungstyp,markiert)
	}
	
	
	
	;MsgBox,% markiert
	;msgbox,x%lin3x% y%lin3y% w%lin3w% h%lin3h%`nx%lin4x% y%lin4y% w%lin4w% h%lin4h%
	
	
	
	
	guicontrol,move,%element%lin1 , x%lin1x% y%lin1y% w%lin1w% h%lin1h%  
	gdipLinieZeichnen(%element%lin1,lin1w,lin1h,,markiert)
	
	guicontrol,move,%element%lin2, x%lin2x% y%lin2y% w%lin2w% h%lin2h%  
	gdipLinieZeichnen(%element%lin2,lin2w,lin2h,,markiert)
	
	
		
	guicontrol,move,%element%lin3, x%lin3x% y%lin3y% w%lin3w% h%lin3h%  
	gdipLinieZeichnen(%element%lin3,lin3w,lin3h,,markiert)
	
	
	
	guicontrol,move,%element%lin4, x%lin4x% y%lin4y% w%lin4w% h%lin4h% 
	gdipLinieZeichnen(%element%lin4,lin4w,lin4h,,markiert)
	
	guicontrol,move,%element%lin5, x%lin5x% y%lin5y% w%lin5w% h%lin5h% 
	gdipLinieZeichnen(%element%lin5,lin5w,lin5h,,markiert)
	
	
	
}


gdipLinieZeichnen(ByRef Variable,w,h, Text="",markiert="false" )
{
	; We first want the hwnd (handle to the picture control) so that we know where to put the bitmap we create
	; We also want to width and height (posw and Posh)
	;GuiControlGet, Pos, Pos, Variable
	GuiControlGet, hwnd, hwnd, Variable
	TextOptions:="x0p y15p s10 Center cff000000  Bold"
	Font:="Arial"
	Posw:=w
	Posh:=h
	if markiert=false
		Foreground=0xff000000
	else
		Foreground=0xff009900
	;msgbox,% markiert
	; Create 2 brushes, one for the background and one for the foreground. Remember this is in ARGB
	pBrushFront := Gdip_CreatePen(Foreground,2)
	
	
	; Create a gdi+ bitmap the width and height that we found the picture control to be
	; We will then get a reference to the graphics of this bitmap
	; We will also set the smoothing mode of the graphics to 4 (Antialias) to make the shapes we use smooth
	pBitmap := Gdip_CreateBitmap(Posw, Posh)
	G := Gdip_GraphicsFromImage(pBitmap)
	Gdip_SetSmoothingMode(G, 4)
	
	
	
	; We will then fill a rounded rectangle with our other brush, starting at x = 4 and y = 4
	; The total width is now Posw-8 as we have slightly indented the actual progress bar
	; The last parameter which is the amount the corners will be rounded by in pixels has been made to be 3 pixels...
	; ...however I have made it so that they are smaller if the percentage is too small as it cannot be rounded by that much
	;Gdip_FillRoundedRectangle(G, pBrushFront, 4, 4, (Posw-8)*(Percentage/100), Posh-8, (Percentage >= 3) ? 3 : Percentage)
	Gdip_DrawRectangle(G, pBrushFront, 0, 0, posw, posh)
	
	; As mentioned in previous examples, we will provide Gdip_TextToGraphics with the width and height of the graphics
	; We will then write the percentage centred onto the graphics (Look at previous examples to understand all options)
	; I added an optional text parameter at the top of this function, to make it so you could write an indication onto the progress bar
	; such as "Finished!" or whatever, otherwise it will write the percentage to it
	;Gdip_TextToGraphics(G, text, TextOptions, Font, posw, posh)
	
	; We then get a gdi bitmap from the gdi+ one we've been working with...
	hBitmap := Gdip_CreateHBITMAPFromBitmap(pBitmap)
	; ... and set it to the hwnd we found for the picture control
	SetImage(hwnd, hBitmap)
	
	; We then must delete everything we created
	; So the 2 brushes must be deleted
	; Then we can delete the graphics, our gdi+ bitmap and the gdi bitmap
	Gdip_Deletepen(pBrushFront)
	Gdip_DeleteGraphics(G), Gdip_DisposeImage(pBitmap), DeleteObject(hBitmap)
	Return, 0
}